﻿

Procedure CreateMoreDirectory(Path.s) ; Создание множества папок по абсолютному пути.
  Protected Result, CurrentPath.s
  Protected Count, i, Dir.s
  
  Result=#True
  CurrentPath=""
  If Path<>""
    Dir=GetPathPart(Path)
    If FileSize(Dir)<>-2
      ReplaceString(Path, "/", "\", #PB_String_InPlace)
      Count=CountString(Path, "\")
      If Count>=2
        CurrentPath=StringField(Path, 1, "\")+"\"
        For i=2 To Count
          Dir = StringField(Path, i, "\")
          If Dir<>""
            CurrentPath+Dir+"\"
            If FileSize(CurrentPath)<>-2
              If CreateDirectory(CurrentPath)=0
                Result=#False
                Break
              EndIf
            EndIf
          EndIf
        Next i
      EndIf
    EndIf
  Else
    Result=#False
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure LogWriteFile(FilePath.s, Str.s)
  Protected ID, Result=#False
  
  If CreateMoreDirectory(FilePath) = #True
    ID = OpenFile(#PB_Any, FilePath, #PB_File_SharedRead|#PB_File_Append)
    If ID
      CompilerIf #PB_Compiler_Unicode      ; Юникодная прога.
        If Lof(ID)=0                       ; Файл пустой.
          WriteStringFormat(ID, #PB_UTF8)  ; Кодировка UTF-8.
        EndIf
        WriteStringN(ID, Str, #PB_UTF8)
      CompilerElse                         ; ASCII прога.
        WriteStringN(ID, Str, #PB_Ascii)
      CompilerEndIf
      CloseFile(ID)
      Result=#True
    EndIf
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure LogWrite(String.s, Type.a)
  Protected Image, Date, r.Rect, x=#False
  
  If String
    
    Date = Date()
    
    With gSetting\Log
      
      If (Type = #Log_TM_Info And \InfoShow) Or 
         (Type = #Log_TM_Warning And \WarnShow) Or
         (Type = #Log_TM_Error And \ErrShow)
        
        Select Type
          Case #Log_TM_Info    : Image = #Img_Window_Setting_0
          Case #Log_TM_Warning : Image = #Img_Window_Setting_1
          Case #Log_TM_Error   : Image = #Img_Window_Setting_2
        EndSelect
        
        AddGadgetItem(#ListView_Log, -1, "["+FormatDate("%hh:%ii:%ss", Date)+"]  "+String,
                      ImageID(Image))
        x=#True
      EndIf
      
      If gVar\LogInfo_FileName
        If (Type = #Log_TM_Info And \InfoFile) Or 
           (Type = #Log_TM_Warning And \WarnFile) Or
           (Type = #Log_TM_Error And \ErrFile)
          
          If LogWriteFile(gVar\LogInfo_FileName, 
                          "["+FormatDate("%dd/%mm/%yyyy %hh:%ii:%ss", Date)+"]  "+String) = #False
            AddGadgetItem(#ListView_Log, -1, "["+FormatDate("%hh:%ii:%ss", Date)+"]  "+
                                             "Ошибка записи в лог-файл",ImageID(#Img_Window_Setting_1))
            x=#True
          EndIf
          
        EndIf
      EndIf
      
    EndWith
    
    If x=#True And gSetting\Log\AutoScroll
      ; Автопрокрутка.
      SendMessage_(GadgetID(#ListView_Log), #LVM_GETITEMRECT, 0, @r)
      SendMessage_(GadgetID(#ListView_Log), #LVM_SCROLL, 0,
                   ((r\bottom - r\top)*(CountGadgetItems(#ListView_Log)-1)))
    EndIf
    
  EndIf
  
EndProcedure


Procedure TermoLog()
  Static CountSavesSec.l=1
  Protected SaveLog=#False
  Protected String.s, Str.s, i
  Protected *Sensor.SensorParam
  
  With gSetting\Log\Termo
    
    If \CheckSavesSec
      If CountSavesSec < \SavesSec
        CountSavesSec+1
      Else
        CountSavesSec=1
        SaveLog=#True
      EndIf
    EndIf
    
    If SaveLog=#False And (\CheckSensorErr Or \CheckMaxTermo Or \CheckModify)
      
      For i=#Sensor_Use_d1 To #Sensor_Use_d6
        
        *Sensor=FindSensor_Use(i)
        If *Sensor
                    
          If \CheckSensorErr
            If TestBit(*Sensor\Flag, #SensorsFlag_MoreErr)
              SaveLog=#True
              Break
            EndIf
          EndIf
          
          If *Sensor\UpdateCount>0
            
            If \CheckMaxTermo
              If *Sensor\Termo > \MaxTermo
                SaveLog=#True
                Break
              EndIf
            EndIf
            
            If \CheckModify
              If Abs(*Sensor\Termo - *Sensor\TermoLog) >= \Modify
                SaveLog=#True
                Break
              EndIf
            EndIf
            
          EndIf
          
        EndIf
      Next i
      
    EndIf
    
  EndWith
  
  If SaveLog=#True
    String="["+FormatDate("%dd/%mm/%yyyy %hh:%ii:%ss", Date())+"]  "
    
    For i=#Sensor_Use_d1 To #Sensor_Use_d6
      Str="d"+i+" "
      *Sensor=FindSensor_Use(i)
      If *Sensor
        If TestBit(*Sensor\Flag, #SensorsFlag_MoreErr)=#False
          Str+StrF(*Sensor\Termo/10, 1)+" °C"
          *Sensor\TermoLog = *Sensor\Termo
        Else
          Str+"ошибка"
        EndIf
      Else
        Str+"не назначен"
      EndIf
      
      If i<=#Sensor_Use_d5
        String+LSet(Str, 16, " ")
      Else
        String+Str
      EndIf
    Next i
    
    LogWriteFile(gVar\LogTermo_FileName, String)

  EndIf
EndProcedure



; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = -
; EnableUnicode
; EnableXP