﻿
Macro ColumnSetStatus_Text(Str)
  LogWrite(Str, #Log_TM_Warning)
  If MessageHide=#False
    MessageRequester(GetWindowTitle(#Window_Main), Str)
  EndIf
EndMacro


Procedure.s ActiveTimeSec(Time.l)
  Protected Result.s, x, Temp
  x = 0
  Result = ""
  If Time>=0
    
    If Time>=31556926 ; Больше или равно год.
      Temp = Round(Time/31556926, #PB_Round_Down)
      If Temp>0
        x+1
        Result + Str(Temp)+" Год "
        Time = Time % 31556926
      EndIf
    EndIf
    
    Temp = Round(Time/604800, #PB_Round_Down)
    If Temp>0 Or x=1 ; Больше или равно одной неделе.
      x+1
      Result + Str(Temp)+" нед. "
      Time = Time % 604800
    EndIf
    
    If x<=2
      Temp = Round(Time/86400, #PB_Round_Down)
      If Temp>0 Or x=1 ; Больше или равно одни сутки.
        x+1
        Result + Str(Temp)+" дн. "
        Time = Time % 86400
      EndIf
    EndIf
    
    If x<=2
      Temp = Round(Time/3600, #PB_Round_Down)
      If Temp>0 Or x=1
        x+1
        Result + Str(Temp)+" ч. "
        Time = Time % 3600
      EndIf
    EndIf
    
    If x<=2
      Temp = Round(Time/60, #PB_Round_Down)
      If Temp>0 Or x=1
        x+1
        Result + Str(Temp)+" мин. "
        Time = Time % 60
      EndIf
    EndIf
    
    If x<=2 And Time>=0
      Result + Str(Time)+ " сек."
    EndIf
    
  Else
    Result = Chr($221E)
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure.s Coi1_Mode_ToText(Mode)
  Protected Result.s=""
  
  Select Mode
    Case #Col1_Mode_DelayTermo : Result = "'Ожидание нагрева'"
    Case #Col1_Mode_Stabl : Result = "'Стабилизация'"
    Case #Col1_Mode_Valve0 : Result = "'Работа клапана 0 (Головная фракция 1)'"
    Case #Col1_Mode_Valve1 : Result = "'Работа клапана 1 (Г. Фракция)'"
    Case #Col1_Mode_Valve2 : Result = "'Работа клапана 2 (Спирт)'"
    Case #Col1_Mode_Valve3 : Result = "'Работа клапана 3 (Т. Фракция)'"
  EndSelect
  
  ProcedureReturn Result
EndProcedure

Procedure Column1_SetMode(Mode) ; Смена режима работы колонки 1 (Ректификация).
  With gVar\Logic\Col1
    
    \DelayState=#False
    \PWM = 0
        
    Select Mode
      Case #Col1_Mode_DelayTermo
        \DelayState=#False
        \CountDelay=0
      Case #Col1_Mode_Stabl      ; Стабилизация.
        \CountDelay = gSetting\Logic\TimeStable * 60
      Case #Col1_Mode_Valve0     ; Работа клапана 0 - 'Головная фракция 1'.
        If gSetting\Logic\MaxVolume_v0 > 0
          \PWM = gSetting\Logic\Valve1_PWM
          \CounterPWM = 0
          \VolumePWM = (\Volume*(\PWM/100))
          \v0_Volume=0
        Else
          Mode = #Col1_Mode_Valve1
          Goto v1
        EndIf
      Case #Col1_Mode_Valve1     ; Работа клапана 1.
        v1:
        If gSetting\Logic\MaxVolume > 0
          \PWM = gSetting\Logic\Valve1_PWM
          \CounterPWM = 0
          \CountDelay = 0
          \VolumePWM = (\Volume*(\PWM/100))
          \v1_Volume=0
        Else
          Mode = #Col1_Mode_Valve2
          Goto v2
        EndIf
      Case #Col1_Mode_Valve2     ; Работа клапана 2.
        LogWrite("Работа клапана 1 завершена. Отобрано "+
                 StrD(\v1_Volume/1000, 3)+" литров.", #Log_TM_Info)
        v2:
        \PWM = 100
        \CounterPWM = 0
        \CountDelay = 0
        \VolumePWM = (\Volume*(\PWM/100))
        \v2_CloseState=#False
        \v2_Volume=0
      Case #Col1_Mode_Valve3     ; Работа клапана 3.
      LogWrite("Работа клапана 2 завершена. Отобрано "+
                       StrD(\v2_Volume/1000, 3)+" литров.", #Log_TM_Info)
        \PWM = gSetting\Logic\Valve3_PWM
        \CounterPWM = 0
        \CountDelay = 0
        \VolumePWM = (\Volume*(\PWM/100))
    EndSelect
    
    LogWrite("Режим работы колонки 1 (Ректификация) изменен на "+Coi1_Mode_ToText(Mode), #Log_TM_Info)
    SetLedColor(#Led_Valve1, #LedColor_Off)
    SetLedColor(#Led_Valve2, #LedColor_Off)
    SetLedColor(#Led_Valve3, #LedColor_Off)
    SetGadgetText(#String_PWM, "")
    
    \Mode = Mode
  EndWith
EndProcedure

Procedure ColumnSetStatus(Column.a, Status.a, MessageHide=#False)
  Protected Result=#False, ErrStatus.a
  Protected *s.SensorParam, St.a, String.s
  
  St = Status
  ErrStatus = Bool(TestBit(Status, #Status_Err))
  If ErrStatus
    St = #StatusStop
  EndIf
    
  Select Column
      
    Case #Col_1
      
      With gVar\Logic\Col1
        
        Select St
          Case #StatusStart
            
            ; Производительность установки мл/сек.
            \Volume = gSetting\Logic\Performance / 3600
            SetGadgetText(#Text_Col1_State, "")
            
            If \Status = #StatusPause
              \Status = #StatusStart
              LogWrite("Продолжена работа колонки 1 (Ректификация)", #Log_TM_Info)
              Result=#True
            Else
              If gVar\Logic\Alarm=0
                If gVar\Sensors\PortID
                  *s = FindSensor_Use(#Sensor_Use_d3)
                  If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
                    \Status = #StatusStart
                    \DelayState=#False
                    \CountDelay=0
                    \PWM=0
                    \CounterPWM=0
                    \v1_Volume=0
                    \v2_Volume=0
                    \v2_CloseState=#False
                    Result=#True
                    LogWrite("Начата работа колонки 1 (Ректификация)", #Log_TM_Info)
                  Else
                    String="Датчик не назначен для колонки 1 (Ректификация) или он нестабильно работает!"
                    ColumnSetStatus_Text(String)
                  EndIf
                Else
                  String="Для работы колонки 1 (Ректификация) нужно открыть COM порт к которому подключены датчики!"
                  ColumnSetStatus_Text(String)
                EndIf
              Else
                String="Для запуска колонки 1 (Ректификация) нужно перезапустить программу!"
                ColumnSetStatus_Text(String)
              EndIf
            EndIf
            
          Case #StatusPause
            
            If \Status = #StatusStart
              \Status = #StatusPause
              Result=#True
              LogWrite("Работа колонки 1 (Ректификация) приостановлена (пауза)", #Log_TM_Info)
              SetGadgetText(#Text_Col1_State, "Работа колонки приостановлена (пауза)")
            EndIf
            
          Case #StatusStop
            If \Status<>#StatusStop
              \Status = #StatusStop
              \Mode=#Col1_Mode_DelayTermo
              \DelayState=#False
              \CountDelay=0
              LogWrite("Остановлена работа колонки 1 (Ректификация)", #Log_TM_Info)
            EndIf
            SetGadgetText(#Text_Col1_State, "")
            Result=#True
            SetLedColor(#Led_Column, #LedColor_Off)
            SetLedColor(#Led_Valve1, #LedColor_Off)
            SetLedColor(#Led_Valve2, #LedColor_Off)
            SetLedColor(#Led_Valve3, #LedColor_Off)
          Case #StatusSkip
            If \Status = #StatusStart Or \Status = #StatusPause
              If \Status = #StatusPause
                \Status = #StatusStart
                Result=#True
                Status=#StatusStart
              EndIf
              \Mode+1
              If \Mode>#Col1_Mode_Valve3
                ColumnSetStatus(#Col_1, #StatusStop)
              Else
                LogWrite("Был пропущен режим - "+Coi1_Mode_ToText(\Mode-1), #Log_TM_Info)
                Column1_SetMode(\Mode)
              EndIf
            EndIf
        EndSelect
        
      EndWith
      
    Case #Col_2
      
      With gVar\Logic\Col2
        
        Select St
          Case #StatusStart
            If gVar\Logic\Alarm=0
              If gVar\Sensors\PortID
                *s = FindSensor_Use(#Sensor_Use_d4)
                If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
                  If *s\Termo < gSetting\WinMain\d4_Limit
                    SetLedColor(#Led_Cube, #LedColor_Green)
                    Result=#True
                    \Work=#True
                    LogWrite("Начата работа колонки 2 (Дистилляция)", #Log_TM_Info)
                  Else
                    String="Запуск колонки 2 (Дистилляция) невозможен, т. к. температура выше порога!"
                    ColumnSetStatus_Text(String)
                  EndIf
                Else
                  String="Датчик не назначен для колонки 2 (Дистилляция) или он нестабильно работает!"
                  ColumnSetStatus_Text(String)
                EndIf
              Else
                String="Для работы колонки 2 (Дистилляция) нужно открыть COM порт к которому подключены датчики!"
                ColumnSetStatus_Text(String)
              EndIf
            Else
              String="Для запуска колонки 2 (Дистилляция) нужно перезапустить программу!"
              ColumnSetStatus_Text(String)
            EndIf
          Case #StatusStop
            If \Work
              \Work=#False
              LogWrite("Остановлена работа колонки 2 (Дистилляция)", #Log_TM_Info)
            EndIf
            SetLedColor(#Led_Cube, #LedColor_Off)
            Result=#True
        EndSelect
        
      EndWith
      
    Case #Col_3
      
      With gVar\Logic\Col3
        
        Select St
          Case #StatusStart
            
            \PinMax=0
            \PinMin=0
            \OldMax=0
            \OldMin=0
            If gVar\Sensors\PortID
              If gSetting\WinMain\d5_LimitMax > gSetting\WinMain\d5_LimitMin
                *s = FindSensor_Use(#Sensor_Use_d5)
                If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
                  \Work=#True
                  Result=#True
                  LogWrite("Начата работа колонки 3 (Брага)", #Log_TM_Info)
                Else
                  String="Датчик не назначен для клонки 3 (Брага) или он нестабильно работает!"
                  ColumnSetStatus_Text(String)
                EndIf
              Else
                String="В колонке 3 (Брага) минимальный порог не может быть равен больше максимального!"
                ColumnSetStatus_Text(String)
              EndIf
            Else
              String="Для работы колонки 3 (Брага) нужно открыть COM порт к которому подключены датчики!"
              ColumnSetStatus_Text(String)
            EndIf
            
          Case #StatusStop
            \PinMax=0
            \PinMin=0
            \OldMax=0
            \OldMin=0
            Result=#True
            If \Work
              \Work=#False
              LogWrite("Остановлена работа колонки 3 (Брага)", #Log_TM_Info)
            EndIf
            SetLedColor(#Led_BragaMax, #LedColor_Off)
            SetLedColor(#Led_BragaMin, #LedColor_Off)
        EndSelect
        
      EndWith
      
  EndSelect
  
  
  
  If Result=#True
    SetGUI_Status(Column, Status)
  EndIf
  
  ProcedureReturn Result
EndProcedure


Procedure Col1_AutoPause()
  If gSetting\Logic\CheckCol1_Auto
    ColumnSetStatus(#Col_1, #StatusPause)
  EndIf
EndProcedure

Procedure Column1() ; Логика колонки 1.
  Protected *s.SensorParam, Termo.w=-2000
  Protected String.s=""
  
  With gVar\Logic\Col1
    
    If \Status = #StatusStart
      
      String+"Текущий режим - "+Coi1_Mode_ToText(\Mode)+"."
      
      If \CountDelay>0
        If \DelayState=#True
          String+" Порог превышен. Задержка смены режимов (осталось "+ActiveTimeSec(\CountDelay)+")"
          \CountDelay-1
        EndIf
      EndIf
      
      *s = FindSensor_Use(#Sensor_Use_d3)
      If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
        
        
        If *s\UpdateCount>0
          Termo = *s\Termo
          If *s\Termo >= gSetting\WinMain\d3_Limit ; Превышение порога.
            SetLedColor(#Led_Column, #LedColor_Red)
          Else
            SetLedColor(#Led_Column, #LedColor_Off)
          EndIf
        EndIf
        
        
        Select \Mode
          Case #Col1_Mode_DelayTermo ; После запуска колонки ожидаем перехода порога датчика 3.
            
            If Termo>-2000
              If Termo >= gSetting\Logic\TermoNextMode ; Превышение порога.
                If \DelayState=#False
                  \DelayState=#True
                  \CountDelay=gSetting\Logic\DelayMode
                ElseIf \CountDelay<=0 ; Переход в режим стабилизации.
                  \DelayState=#False
                  Column1_SetMode(#Col1_Mode_Stabl)
                EndIf
              Else ; Температура ниже порога.
                
                If \DelayState=#False
                  String+" (порог: "+StrF(gSetting\Logic\TermoNextMode/10, 1)+" °C)"
                EndIf
                
                If \DelayState=#True
                  \DelayState=#False
                  \CountDelay=0
                EndIf
              EndIf
            EndIf
            
          Case #Col1_Mode_Stabl      ; Стабилизация.
            
            If \CountDelay>0
              String+" Осталось "+ActiveTimeSec(\CountDelay)
              \CountDelay-1
            Else
              If Termo>-2000
                If Termo < gSetting\WinMain\d3_Limit ; Порог не превышен.
                  Column1_SetMode(#Col1_Mode_Valve0)
                  Col1_AutoPause()
                Else
                  String+" Порог превышен. Перегрев "+StrF((Termo-gSetting\WinMain\d3_Limit+1)/10, 1)+" °C"+
                         " Ожидание снижения температуры до "+
                         StrF((gSetting\WinMain\d3_Limit-1)/10, 1)+" °C"
                EndIf
              EndIf
            EndIf
            
          Case #Col1_Mode_Valve0     ; Работа клапана 0 - 'Головная фракция 1'.
            
            \v0_Volume + \VolumePWM
            
            If \v0_Volume>=gSetting\Logic\MaxVolume_v0 ; Требуемый объем прошел через клапан.
              Column1_SetMode(#Col1_Mode_Valve1)
              Col1_AutoPause()
            Else
              String+" Осталось "+StrD((gSetting\Logic\MaxVolume_v0-\v0_Volume)/1000, 3)+" литров."+
                     " Будет завершено через "+
                     ActiveTimeSec((gSetting\Logic\MaxVolume_v0-\v0_Volume)/\VolumePWM)
            EndIf
            
          Case #Col1_Mode_Valve1     ; Работа клапана 1.
            
            SetLedColor(#Led_Valve1, #LedColor_Green)
            
            \v1_Volume + \VolumePWM
            SetGadgetText(#String_Valve1, StrD(\v1_Volume/1000, 3))
            If \v1_Volume>=gSetting\Logic\MaxVolume ; Требуемый объем прошел через клапан.
              Column1_SetMode(#Col1_Mode_Valve2)
              Col1_AutoPause()
            Else
              String+" Осталось "+StrD((gSetting\Logic\MaxVolume-\v1_Volume)/1000, 3)+" литров."+
                     " Будет завершено через "+
                     ActiveTimeSec((gSetting\Logic\MaxVolume-\v1_Volume)/\VolumePWM)
            EndIf
            
          Case #Col1_Mode_Valve2     ; Работа клапана 2.
            
            If Termo>-2000
              
              If Termo >= gSetting\WinMain\d3_Limit ; Превышение порога.
                \v2_CloseState=#True                ; Закрыли клапан.
                
                
                If \DelayState=0 Or \DelayState=3
                  \DelayState=1
                  \CountDelay=gSetting\Logic\DelayMode
                ElseIf (\DelayState=1 And \CountDelay<=0)
                  ;If \DelayState<>3
                    \PWM-20      ; Снижаем ШИМ на 20%.
                    \CounterPWM=0
                    If \PWM<20   ; Работа клапана 2 на этом закончена.
                      Column1_SetMode(#Col1_Mode_Valve3)
                      Col1_AutoPause()
                    Else
                      \VolumePWM = (\Volume*(\PWM/100))
                      LogWrite("ШИМ клапана 2 снижен до "+\PWM+"  Температура датчика 3 составляет "+
                               StrF(Termo/10, 1)+" °C", #Log_TM_Info)
                    EndIf
                  ;EndIf
                  \CountDelay=gSetting\Logic\Valve2_Stable*60 ; Переходим в режим стабилизации клапана 2.
                  \DelayState=2
                ElseIf \DelayState=2
                  String+" Стабилизация. До завершения осталось "+ActiveTimeSec(\CountDelay)+
                         "Перегрев составляет "+StrF((Termo-gSetting\WinMain\d3_Limit)/10, 1)+" °C"
                  \CountDelay-1
                  If \CountDelay<=0 ; Температура была больше порога на протяжении времени стабилизации.
                    Column1_SetMode(#Col1_Mode_Valve3)
                    Col1_AutoPause()
                  EndIf
                EndIf
                
              Else ; Температура ниже порога.
                
                If \DelayState>0
                  If \DelayState=1 Or \DelayState=2
                    \DelayState=3 ; Задержка смены режимов для предотвращения лавинообразного снижения ШИМ.
                    \CountDelay=gSetting\Logic\DelayMode
                  ElseIf \DelayState=3
                    String+" Предотвращение лавинообразного снижения ШИМ. Осталось "+ActiveTimeSec(\CountDelay)
                    \CountDelay-1
                    If \CountDelay<=0
                      \DelayState=0
                    EndIf
                  EndIf
                EndIf
                
                If \v2_CloseState=#True ; Клапан до этого был закрыт.
                  \v2_CloseState=#False ; Открыли клапан 2.
                  \CounterPWM=0         ; Сброс ШИМ счетчика.
                EndIf
                
              EndIf
            EndIf
            
            If \v2_CloseState=#False And \Mode=#Col1_Mode_Valve2
              \v2_Volume + \VolumePWM
              SetGadgetText(#String_Valve2, StrD(\v2_Volume/1000, 3))
              SetLedColor(#Led_Valve2, #LedColor_Green)
            Else
              SetLedColor(#Led_Valve2, #LedColor_Off)
            EndIf
            
          Case #Col1_Mode_Valve3     ; Работа клапана 3.
            SetLedColor(#Led_Valve3, #LedColor_Green)
            
            If Termo>-2000
              If Termo>=gSetting\Logic\Valve3_Termo
                LogWrite("Превышен порог температуры при работе клапана 3!", #Log_TM_Info)
                ColumnSetStatus(#Col_1, #StatusStop)
              Else
                String + " До превышения порога ("+StrF(gSetting\Logic\Valve3_Termo/10, 1)+" °C"+
                         ") осталось "+StrF((gSetting\Logic\Valve3_Termo-Termo)/10, 1)+" °C"
              EndIf
            EndIf
            
        EndSelect
        
        If \Mode>#Col1_Mode_Stabl And Termo>-2000 And Termo<gSetting\Logic\Col1_MinTermo
          LogWrite("Работа колонки 1 (Ректификация) остановлена т. к. текущая температура ("+
                   StrF(Termo/10, 1)+" °C"+") меньше допустимой ("+
                   StrF(gSetting\Logic\Col1_MinTermo/10, 1)+" °C)!",
                   #Log_TM_Warning)
          ColumnSetStatus(#Col_1, #StatusStop)
        Else
          
          If \Status=#StatusStart And GetGadgetText(#Text_Col1_State) <> String
            SetGadgetText(#Text_Col1_State, String)
          EndIf
          
          If \Mode=#Col1_Mode_Valve0 Or \Mode=#Col1_Mode_Valve1 Or \Mode=#Col1_Mode_Valve2 Or 
             \Mode=#Col1_Mode_Valve3
            String = Str(\PWM)
          Else
            String = ""
          EndIf
          If GetGadgetText(#String_PWM) <> String
            SetGadgetText(#String_PWM, String)
          EndIf
          
        EndIf
      Else
        LogWrite("Работа колонки 1 (Ректификация) остановлена из-за ошибки датчика!", #Log_TM_Error)
        ColumnSetStatus(#Col_1, #StatusStop)
      EndIf
      
    EndIf
    
  EndWith
EndProcedure


Procedure Column2() ; Логика колонки 2.
  Protected *s.SensorParam
    
  With gVar\Logic\Col2
    
    If \Work
      *s = FindSensor_Use(#Sensor_Use_d4)
      If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
        If *s\UpdateCount>0
          If *s\Termo >= gSetting\WinMain\d4_Limit
            LogWrite("Работа колонки 2 (Дистилляция) остановлена из-за превышения порога.", #Log_TM_Info)
            ColumnSetStatus(#Col_2, #StatusStop)
          EndIf
        EndIf
      Else
        LogWrite("Работа колонки 2 (Дистилляция) остановлена из-за ошибки датчика!", #Log_TM_Error)
        ColumnSetStatus(#Col_2, #StatusStop)
      EndIf
      
    EndIf
  EndWith
EndProcedure

Procedure Column3() ; Логика колонки 3.
  Protected *s.SensorParam;, Min.a, Max.a
    
  With gVar\Logic\Col3
    
    If \Work
      *s = FindSensor_Use(#Sensor_Use_d5)
      If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
        
        If *s\UpdateCount>0
          
          If *s\Termo =< gSetting\WinMain\d5_LimitMax
            \PinMax = #False
          ElseIf *s\Termo >= gSetting\WinMain\d5_LimitMax + gSetting\Logic\Hysteresis_Col3
            \PinMax = #True
          EndIf
          
          If *s\Termo >= gSetting\WinMain\d5_LimitMin
            \PinMin = #False
          ElseIf *s\Termo =< gSetting\WinMain\d5_LimitMin - gSetting\Logic\Hysteresis_Col3
            \PinMin = #True
          EndIf
          
;           
          If \PinMax<>\OldMax
            If \PinMax
              SetLedColor(#Led_BragaMax, #LedColor_Green)
            Else
              SetLedColor(#Led_BragaMax, #LedColor_Off)
            EndIf
          EndIf
          
          If \PinMin<>\OldMin
            If \PinMin
              SetLedColor(#Led_BragaMin, #LedColor_Green)
            Else
              SetLedColor(#Led_BragaMin, #LedColor_Off)
            EndIf
          EndIf
          
          \OldMax = \PinMax
          \OldMin = \PinMin
          
          If \PinMax And \PinMin ; Похоже что значние верхнего порога выше чем у нижнего.
            LogWrite("Работа колонки 3 (Брага) остановлена (справедливо условие верхнего и нижнего порога)!"+
                     "Проверьте корректность настроек порогов.", #Log_TM_Error)
            ColumnSetStatus(#Col_3, #StatusStop)
          EndIf
          
        EndIf
      Else
        LogWrite("Работа колонки 3 (Брага) остановлена из-за ошибки датчика!", #Log_TM_Error)
        ColumnSetStatus(#Col_3, #StatusStop)
      EndIf
    Else
      \PinMax=0
      \PinMin=0
      \OldMax=0
      \OldMin=0
    EndIf
  EndWith
EndProcedure

Procedure TermoAlarmAnalysis() ; Анализ данных с аварийных датчиков .
  Protected *s.SensorParam
  
  If gVar\Logic\Alarm=#False
    
    *s=FindSensor_Use(#Sensor_Use_d1)
    If *s
      If TestBit(*s\Flag, #SensorsFlag_MoreErr)
        gVar\Logic\Alarm=#True
        LogWrite("Обнаружена ошибка датчика 1 (ав. ТСА)!", #Log_TM_Warning)
      ElseIf *s\UpdateCount>0 And *s\Termo>=gSetting\WinMain\d1_Limit
        gVar\Logic\Alarm=#True
        LogWrite("Превышение порога датчика 1 (ав. ТСА)! Температура "+
                 StrF(*s\Termo/10, 1)+"  Порог "+StrF(gSetting\WinMain\d1_Limit/10, 1), #Log_TM_Warning)
      EndIf
    Else
      gVar\Logic\Alarm=#True
      LogWrite("Не назначен датчик 1 (ав. ТСА)!", #Log_TM_Warning)
    EndIf
    
    *s=FindSensor_Use(#Sensor_Use_d2)
    If *s
      If TestBit(*s\Flag, #SensorsFlag_MoreErr)
        gVar\Logic\Alarm=#True
        LogWrite("Обнаружена ошибка датчика 2 (ав. Конденсатор)!", #Log_TM_Warning)
      ElseIf *s\UpdateCount>0 And *s\Termo>=gSetting\WinMain\d2_Limit
        gVar\Logic\Alarm=#True
        LogWrite("Превышение порога датчика 2 (ав. Конденсатор)! Температура "+
                 StrF(*s\Termo/10, 1)+"  Порог "+StrF(gSetting\WinMain\d2_Limit/10, 1),#Log_TM_Warning)
      EndIf
    Else
      gVar\Logic\Alarm=#True
      LogWrite("Не назначен датчик 2 (ав. Конденсатор)!", #Log_TM_Warning)
    EndIf
    
    If gVar\Logic\Alarm=#True
      LogWrite("Работа колонок 'Ректификация' и 'Дистилляция' заблокирована до перезапуска программы!",
               #Log_TM_Warning)
      ColumnSetStatus(#Col_1, #StatusStop|#Status_Err)
      ColumnSetStatus(#Col_2, #StatusStop|#Status_Err)
      SetLedColor(#Led_Alarm, #LedColor_Red)
    EndIf
    
  EndIf
  
EndProcedure

Procedure Termo_d6()
  Protected *s.SensorParam
  
  If gSetting\Logic\Check_d6 ; Разрешена работа датчика 6.
    
    *s = FindSensor_Use(#Sensor_Use_d6)
    If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False
      
      If *s\UpdateCount>0
        If *s\Termo >= gSetting\Logic\Termo_d6 ; Превышен порог.
          gVar\Logic\d6_Pin=#False
        Else ; Порог не превышен.
          If *s\Termo =< gSetting\Logic\Termo_d6 - gSetting\Logic\Hysteresis_d6
            gVar\Logic\d6_Pin=#True
          EndIf
        EndIf
      EndIf
      
    Else
      gVar\Logic\d6_Pin=#False
    EndIf
    
  Else
    gVar\Logic\d6_Pin=#False
  EndIf
  
EndProcedure

Procedure Columns() ; Логика колонок.
  
  If gVar\Sensors\PortID=0 ; COM порт закрыт.
    With gVar\Logic
    If \Col1\Status <> #StatusStop
      ColumnSetStatus(#Col_1, #StatusStop)
    EndIf
    
    If \Col2\Work
      ColumnSetStatus(#Col_2, #StatusStop)
    EndIf
    
    If \Col3\Work
      ColumnSetStatus(#Col_3, #StatusStop)
    EndIf
    
    EndWith
  EndIf
  
  TermoAlarmAnalysis()
  
  Column1()
  Column2()
  Column3()
  
  Termo_d6()
  
EndProcedure

Procedure SaveSetting_WinMain()
  
  With gSetting\WinMain
    If \UpdateSetting<=10 ; Настройки в главном окне были изменены. 
      
      If \UpdateSetting=10
        SaveSetting()
      EndIf
      
      \UpdateSetting+1
    EndIf
  EndWith
  
EndProcedure

Procedure ClearUpdateFlag() ; Очистка флага обновления данных датчиков.
  Protected *s.SensorParam, i
  
  For i=#Sensor_Use_d1 To #Sensor_Use_d6
    *s = FindSensor_Use(i)
    If *s
      If TestBit(*s\Flag, #SensorsFlag_Update) Or *s\UpdateCount>0
        ClearBit(*s\Flag, #SensorsFlag_Update)
        *s\CountNoUpdate = 0
        If *s\UpdateCount>0
          *s\UpdateCount-1
        EndIf
      Else ; По какой-то причине данные не были прочитаны.
        If *s\CountNoUpdate<#Sensor_MaxNoUpdate
          *s\CountNoUpdate + 1
        Else
          SetBit(*s\Flag, #SensorsFlag_MoreErr)
        EndIf
      EndIf
    EndIf
  Next i
  
EndProcedure

Procedure TimerSensor() ; Вызывается по таймеру каждую секунду.
  Static IsWork=#False
  
  If IsWork=#False
    IsWork=#True
    SaveSetting_WinMain()
    
    TermoLog()
    
    Columns()
    MainWin_SetTermo()
    
    If gSetting\Sensor\IsWindow
      WinSensor_SetTable() ; Если открыто окно настроек, обновляем информацию о температуре в таблице датчиков.
    EndIf    
    
    ClearUpdateFlag()
        
    IsWork=#False
  EndIf
  
EndProcedure


Procedure TimerPWM() ; Вызывается по таймеру каждые 0.1 секунды.
  Static IsWork=#False
  
  If IsWork=#False
    IsWork=#True
    USB_Core()
    LPT_Core() ; Основная функция работы с LPT портом.
    IsWork=#False
  EndIf
EndProcedure



; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = ---
; EnableUnicode
; EnableXP
; CompileSourceDirectory