﻿
#USB_PID=$18E0
#USB_VID=$5B2A

Define UsbHid_Handle.i=0

Procedure USB_IsDevice()
  Shared UsbHid_Handle
  
  ProcedureReturn Bool(UsbHid_Handle)
EndProcedure

Procedure USB_End()
  Shared UsbHid_Handle
  
  HID::CloseDevice(UsbHid_Handle)
  UsbHid_Handle = 0
  
EndProcedure

Procedure USB_Core()
  Static Counter=10, Old_Test
  Static PulseCount=0, CountErrOut=0
  Shared UsbHid_Handle
  Protected Test, OutBuff.u = 0
  Protected ErrStatus=#False
  Protected Dim UsbOutBuff.a(3)
  
  Counter+1
  If Counter>=10
    Counter=0
    
    Test=HID::TestDevice(#USB_PID, #USB_VID)
    If Test<>Old_Test
      Old_Test=Test
      If Test 
        HID::CloseDevice(UsbHid_Handle)
        UsbHid_Handle=HID::OpenDevice(#USB_PID, #USB_VID)
        LogWrite("Подключено USB устройство вывода", #Log_TM_Info)
      Else
        HID::CloseDevice(UsbHid_Handle)
        UsbHid_Handle=0
        LogWrite("Отключено USB устройство вывода", #Log_TM_Warning)
      EndIf
    EndIf
    
  EndIf
  
  
  If UsbHid_Handle
    
    ; Пульсирующий сигнал.
    If PulseCount>=45
      SetBit(OutBuff, NumToBit(#LPT_Pin_Pulse))
    EndIf
    
    PulseCount+1
    If PulseCount>=50
      PulseCount=0
    EndIf
    
    If gVar\Logic\Alarm=0 ; Аварийные датчики не сработали.
      
      With gVar\Logic\Col1
        If \Status = #StatusStop Or \Status=#StatusPause ; Ручное управление клапанами.
          If \ControlValves>0
            Select \ControlValves
              Case 1 ; Первый клапан.
                SetBit(OutBuff, NumToBit(#LPT_Pin_Valve1))
              Case 2 ; Второй клапан.
                SetBit(OutBuff, NumToBit(#LPT_Pin_Valve2))
              Case 3 ; Третий клапан.
                SetBit(OutBuff, NumToBit(#LPT_Pin_Valve3))
            EndSelect
          EndIf
        ElseIf \Status = #StatusStart ; Автоматическое управление клапанами.
          If \Mode=#Col1_Mode_Valve0 Or \Mode=#Col1_Mode_Valve1 Or \Mode=#Col1_Mode_Valve2 Or
             \Mode=#Col1_Mode_Valve3
            
            If \PWM > \CounterPWM
              Select \Mode
                Case #Col1_Mode_Valve0
                  SetBit(OutBuff, NumToBit(#LPT_Pin_Valve0))
                Case #Col1_Mode_Valve1
                  SetBit(OutBuff, NumToBit(#LPT_Pin_Valve1))
                Case #Col1_Mode_Valve2
                  If \v2_CloseState=#False
                    SetBit(OutBuff, NumToBit(#LPT_Pin_Valve2))
                  EndIf
                Case #Col1_Mode_Valve3
                  SetBit(OutBuff, NumToBit(#LPT_Pin_Valve3))
              EndSelect
            EndIf
            
          EndIf
        EndIf
        
        If \Status <> #StatusStop
          SetBit(OutBuff, NumToBit(#LPT_Pin_Col1))
        EndIf
        
      EndWith
      
      
      If gVar\Logic\Col2\Work
        SetBit(OutBuff, NumToBit(#LPT_Pin_Col2))
      EndIf
      
    Else
      ErrStatus=#True
    EndIf
    
    
    If gVar\Logic\Col3\Work
      If gVar\Logic\Col3\PinMax
        SetBit(OutBuff, NumToBit(#LPT_Pin_Col3_Max))
      EndIf
      
      If gVar\Logic\Col3\PinMin
        SetBit(OutBuff, NumToBit(#LPT_Pin_Col3_Min))
      EndIf
    EndIf
    
    If gSetting\Logic\Check_d6 And ; Разрешена работа датчика 6
       gVar\Logic\d6_Pin=#True     ; и нужно включить канал.
      SetBit(OutBuff, NumToBit(#LPT_Pin_d6))
    EndIf
    
    
    If ErrStatus=#False
      With gVar\Sensors
        ForEach \Sensor()
          If \Sensor()\Use>#Sensor_Use_None And TestBit(\Sensor()\Flag, #SensorsFlag_MoreErr)
            ErrStatus=#True
            Break
          EndIf
        Next
      EndWith
    EndIf
    
    
    If ErrStatus=#True
      SetBit(OutBuff, NumToBit(#LPT_Pin_Err))
    EndIf
    
    UsbOutBuff(0) = 0
    UsbOutBuff(1) = OutBuff & 255
    UsbOutBuff(2) = (OutBuff>>8) & 255
    
    If HID::WriteDevice(UsbHid_Handle, @UsbOutBuff(), 3) = 3
      CountErrOut=0
      ;Debug RSet(Bin(OutBuff, #PB_Unicode),16,"0")
    Else
      Debug GetLastError_()
      CountErrOut+1
      If CountErrOut>=100
        CountErrOut=0
        LogWrite("Ошибка передачи данных USB устройству вывода", #Log_TM_Warning)
      EndIf
    EndIf
    
  EndIf
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = -
; EnableXP
; CompileSourceDirectory