﻿

Procedure SetSpinFloat(Gadget, State.w, UpdateState=#False)
  Protected String.s

  String = Str(State)
  If State>-10 And State<10
    If State>=0
      String="0"+String
    Else
      String="-0"+Str(((~State)&$7FFF)+1)
    EndIf
  EndIf
  String = InsertString(String, ".", Len(String))
  SetGadgetText(Gadget, String)
  If UpdateState
    SetGadgetState(Gadget, State)
  EndIf
  
EndProcedure

Procedure SetLedColor(Led, NumColor)
  Protected Gadget=-1, Img=-1
  
  If (Led>=#Led_Alarm And Led<=#Led_BragaMin) And
     (NumColor>=#LedColor_Off And NumColor<=#LedColor_Green)
    
    Select Led
      Case #Led_Alarm : Gadget = #Image_LedAlarm
      Case #Led_Pulse    : Gadget = #Image_LedPulse
      Case #Led_Column   : Gadget = #Image_LedD3
      Case #Led_Valve1   : Gadget = #Image_Led_Valve1
      Case #Led_Valve2   : Gadget = #Image_Led_Valve2
      Case #Led_Valve3   : Gadget = #Image_Led_Valve3
      Case #Led_Cube     : Gadget = #Image_LedD4
      Case #Led_BragaMax : Gadget = #Image_LedD5_Max
      Case #Led_BragaMin : Gadget = #Image_LedD5_Min
    EndSelect
    
    Select NumColor
      Case #LedColor_Off   : Img = #Img_Window_Main_0
      Case #LedColor_Red   : Img = #Img_Window_Main_1
      Case #LedColor_Green : Img = #Img_Window_Main_2
    EndSelect
    
    If Gadget>-1 And Img>-1
      If IsGadget(Gadget) And GetGadgetData(Gadget)<>NumColor
        SetGadgetState(Gadget, ImageID(Img))
        SetGadgetData(Gadget, NumColor)
      EndIf
    EndIf
    
  EndIf
EndProcedure

Procedure CopyCraphSetting() ; Копирование настроек и других данных для модуля графика.
  Protected s.grh::GraphSetting
  
  With s\Color
    \Back = gSetting\Graph\Color[#GraphColor_Back]
    \Grid = gSetting\Graph\Color[#GraphColor_Grid]
    \Text = gSetting\Graph\Color[#GraphColor_Text]
    \Sensor1 = gSetting\Graph\Color[#GraphColor_Sensor1]
    \Sensor2 = gSetting\Graph\Color[#GraphColor_Sensor2]
    \Sensor3 = gSetting\Graph\Color[#GraphColor_Sensor3]
    \Sensor4 = gSetting\Graph\Color[#GraphColor_Sensor4]
    \Sensor5 = gSetting\Graph\Color[#GraphColor_Sensor5]
    \Sensor6 = gSetting\Graph\Color[#GraphColor_Sensor6]
  EndWith
  s\NewDay=gSetting\Graph\NewDay
  s\AutoScroll=gSetting\Graph\AutoScroll
  grh::GraphSetting(@s)
EndProcedure

Procedure AddGraphData(Date)
  Protected *s.SensorParam, i, Termo.w
  Protected Graph.Grh::GraphData
  
  For i=0 To 5
    
    Termo=-2000
    
    If gVar\Sensors\PortID
      *s = FindSensor_Use(i+#Sensor_Use_d1);TestBit(*s\Flag, #SensorsFlag_Update)
      If *s And TestBit(*s\Flag, #SensorsFlag_MoreErr)=#False And TestBit(*s\Flag, #SensorsFlag_Err)=#False
        Termo=*s\Termo
      EndIf
    EndIf

    Graph\Arr[i]=Termo
    
  Next i
  
  grh::AddData(@Graph, Date)
  grh::GraphDraw()
EndProcedure

Procedure TimerGraph()
  Static IsWork=#False, OldDate.l, CountSkip=0
  Protected Date
  
  Date = Date()
  If IsWork=#False And OldDate<>Date
    IsWork=#True
    
    OldDate=Date
    If CountSkip>=4
      AddGraphData(Date)
    Else
      CountSkip+1
    EndIf
    
    IsWork=#False
  EndIf
  
EndProcedure

Procedure AddLog()
  Protected *Str.String
  
  *Str=EventData()
  If *Str
    LogWrite(*Str\s, EventGadget())
    FreeStructure(*Str)
  EndIf
EndProcedure

Procedure LogPost(String.s, Type)
  Protected *Str.String
  
  *Str = AllocateStructure(String)
  If *Str
    *Str\s=String
    PostEvent(#Event_Log, #Window_Main, Type, 0, *Str)
  EndIf
EndProcedure
  
Procedure GraphLog(String.s, Type)
  Protected mt
  
  Select Type
    Case Grh::#Log_Warning : mt=#Log_TM_Warning
    Case Grh::#Log_Error : mt=#Log_TM_Error
    Default : mt=#Log_TM_Info
  EndSelect
  
  LogPost(String, mt)
  
EndProcedure

Procedure ButtonDelSensor_State()
  Protected x=#True
  
  If IsGadget(#ss_Button_DelSensor)
    With gVar\Sensors
      ForEach \Sensor()
        If TestBit(\Sensor()\Flag, #SensorsFlag_NotFound)
          x=#False
          Break
        EndIf
      Next
    EndWith
    DisableGadget(#ss_Button_DelSensor, x)
  EndIf

EndProcedure

Procedure WinSensor_Find(List Sensors.SensorParam())
  Protected x
  
  ForEach gVar\Sensors\Sensor()
    x=#False
    ForEach Sensors()
      If gVar\Sensors\Sensor()\ID = PeekQ(@Sensors())
        x=#True
        DeleteElement(Sensors())
      EndIf
    Next
    
    If x=#True
      ClearBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_NotFound)
    Else
      SetBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_NotFound)
    EndIf
    
    If Sensor_IsTermoSensor(@gVar\Sensors\Sensor()\SN)
      SetBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
    Else
      ClearBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
    EndIf
  Next
  
  If ListSize(Sensors())>0
    LastElement(gVar\Sensors\Sensor())
    ForEach Sensors()
      If AddElement(gVar\Sensors\Sensor())
        gVar\Sensors\Sensor()\ID = PeekQ(@Sensors())
        gVar\Sensors\Sensor()\Use = #Sensor_Use_None
        gVar\Sensors\Sensor()\Flag = 0
        If Sensor_IsTermoSensor(@gVar\Sensors\Sensor()\SN)
          SetBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
        Else
          ClearBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
        EndIf
        
      EndIf
    Next
  EndIf
  
EndProcedure

Procedure EventSensor()
  Shared gSensorThread
  Protected *s.SensorParam, Find=#False
  
  LockMutex(gSensorThread\Mutex)
  
  With gVar\Sensors
    
    If TestBit(gSensorThread\Flags, #ThS_FlagOut_Find)
      ClearBit(gSensorThread\Flags, #ThS_FlagOut_Find)
      WinSensor_Find(gSensorThread\Sensor())
      Find=#True
    EndIf
    
    
    If TestBit(gSensorThread\Flags, #ThS_FlagOut_SetData)
      ClearBit(gSensorThread\Flags, #ThS_FlagOut_SetData)
      
      gVar\Sensors\PortID = gSensorThread\PortID
      ForEach \Sensor()
        If Sensor_IsTermoSensor(@\Sensor())
          ClearBit(\Sensor()\Flag, #SensorsFlag_Update)
          
          If \Sensor()\Use>#Sensor_Use_None Or gSetting\Sensor\IsWindow
            
            *s=0
            
            ForEach gSensorThread\Sensor()
              If gSensorThread\Sensor()\ID = \Sensor()\ID
                *s=@gSensorThread\Sensor()
                Break
              EndIf
            Next
            
            If *s
              \Sensor()\Flag  = *s\Flag
              \Sensor()\Termo = *s\Termo
              If TestBit(*s\Flag, #SensorsFlag_Update)
                If gVar\IsWin9x=#True ; На Win9x очень длительный опрос датчиков.
                  \Sensor()\UpdateCount = #Sensor_MaxNoInfo * 4
                Else
                  \Sensor()\UpdateCount = #Sensor_MaxNoInfo
                EndIf
              EndIf
            Else
              SetBit(\Sensor()\Flag, #SensorsFlag_NotFound)
            EndIf
            
          EndIf
        EndIf
      Next
      
      ClearList(gSensorThread\Sensor())
      
      
    EndIf
  EndWith
  
  UnlockMutex(gSensorThread\Mutex)
  
  If Find
    ButtonDelSensor_State()
  EndIf
    
EndProcedure

Procedure SetGUI_Status(Column.a, Status.a)
  Select Column
    Case #Col_1
      
      gVar\Logic\Col1\ControlValves=0
      SetLedColor(#Led_Valve1,#LedColor_Off)
      SetLedColor(#Led_Valve2,#LedColor_Off)
      SetLedColor(#Led_Valve3,#LedColor_Off)
      SetGadgetState(#Button_Valve1, 0)
      SetGadgetState(#Button_Valve2, 0)
      SetGadgetState(#Button_Valve3, 0)
      SetGadgetText(#Button_Valve1, "Закр.")
      SetGadgetText(#Button_Valve2, "Закр.")
      SetGadgetText(#Button_Valve3, "Закр.")
      SetGadgetText(#String_PWM, "")
      
      If TestBit(Status, #Status_Err)=#False
        
        Select Status
          Case #StatusStart
            
            DisableGadget(#Spin_d3, #True)
            DisableGadget(#Button_Col1_Start, #True)
            DisableGadget(#Button_Col1_Pause, #False)
            DisableGadget(#Button_Col1_Stop, #False)
            DisableGadget(#Button_Col1_Skip, #False)
            HideGadget(#Button_Valve1, #True)
            HideGadget(#Button_Valve2, #True)
            HideGadget(#Button_Valve3, #True)
            SetGadgetText(#String_Valve1, "")
            SetGadgetText(#String_Valve2, "")
            
          Case #StatusPause
            
            DisableGadget(#Spin_d3, #False)
            DisableGadget(#Button_Col1_Start, #False)
            DisableGadget(#Button_Col1_Pause, #True)
            DisableGadget(#Button_Col1_Stop, #False)
            DisableGadget(#Button_Col1_Skip, #False)
            HideGadget(#Button_Valve1, #False)
            HideGadget(#Button_Valve2, #False)
            HideGadget(#Button_Valve3, #False)
            
          Case #StatusStop
            
            DisableGadget(#Spin_d3, #False)
            DisableGadget(#Button_Col1_Start, #False)
            DisableGadget(#Button_Col1_Pause, #True)
            DisableGadget(#Button_Col1_Stop, #True)
            DisableGadget(#Button_Col1_Skip, #True)
            HideGadget(#Button_Valve1, #False)
            HideGadget(#Button_Valve2, #False)
            HideGadget(#Button_Valve3, #False)
            
          Case #StatusSkip
            
        EndSelect
        
      Else ; Ошибка.
        
        DisableGadget(#Spin_d3, #True)
        DisableGadget(#Button_Col1_Start, #True)
        DisableGadget(#Button_Col1_Pause, #True)
        DisableGadget(#Button_Col1_Stop, #True)
        DisableGadget(#Button_Col1_Skip, #True)
        HideGadget(#Button_Valve1, #True)
        HideGadget(#Button_Valve2, #True)
        HideGadget(#Button_Valve3, #True)
        
      EndIf
      
    Case #Col_2
      
      If TestBit(Status, #Status_Err)=#False
        Select Status
          Case #StatusStart
            DisableGadget(#Spin_d4, #True)
            DisableGadget(#Button_Col2_Start, #True)
            DisableGadget(#Button_Col2_Stop, #False)
          Case #StatusStop
            DisableGadget(#Spin_d4, #False)
            DisableGadget(#Button_Col2_Start, #False)
            DisableGadget(#Button_Col2_Stop, #True)
        EndSelect
      Else ; Ошибка.
        DisableGadget(#Spin_d4, #True)
        DisableGadget(#Button_Col2_Start, #True)
        DisableGadget(#Button_Col2_Stop, #True)
      EndIf
      
    Case #Col_3
      
      If TestBit(Status, #Status_Err)=#False
        Select Status
          Case #StatusStart
            DisableGadget(#Button_Col3_Start, #True)
            DisableGadget(#Button_Col3_Stop, #False)
            DisableGadget(#Spin_d5_Max, #True)
            DisableGadget(#Spin_d5_Min, #True)
          Case #StatusStop
            DisableGadget(#Button_Col3_Start, #False)
            DisableGadget(#Button_Col3_Stop, #True)
            DisableGadget(#Spin_d5_Max, #False)
            DisableGadget(#Spin_d5_Min, #False)
        EndSelect
      Else ; Ошибка.
        DisableGadget(#Button_Col3_Start, #True)
        DisableGadget(#Button_Col3_Stop, #True)
        DisableGadget(#Spin_d5_Max, #False)
        DisableGadget(#Spin_d5_Min, #False)
      EndIf
      
  EndSelect
EndProcedure

Procedure MainWin_SetTermo()
  Protected i, Gadget, Str.s
  Protected *s.SensorParam
  
  For i=#Sensor_Use_d1 To #Sensor_Use_d6
    
    Select i
      Case #Sensor_Use_d1 : Gadget = #String_d1
      Case #Sensor_Use_d2 : Gadget = #String_d2
      Case #Sensor_Use_d3 : Gadget = #String_d3
      Case #Sensor_Use_d4 : Gadget = #String_d4
      Case #Sensor_Use_d5 : Gadget = #String_d5
      Case #Sensor_Use_d6 : Gadget = #String_d6
    EndSelect
    
    Str=""
    
    If gVar\Sensors\PortID
      *s = FindSensor_Use(i)
      If *s
        If TestBit(*s\Flag, #SensorsFlag_MoreErr)
          Str = "Ошибка"
        ElseIf *s\UpdateCount>0
          Str = StrF(*s\Termo/10, 1)+" °C"
        Else
          Continue
        EndIf
      Else
        Str="Не выбран"
      EndIf
    Else
      Str="Нет данных"
    EndIf
    
    SetGadgetText(Gadget, Str)
    
  Next i
EndProcedure

Procedure SetCanvasColor(Gadget, Color)
  If StartDrawing(CanvasOutput(Gadget))
    Box(0, 0, OutputWidth(), OutputHeight(), Color)
    StopDrawing()
  EndIf
EndProcedure

Procedure TestAsciiArray_Duplicate(*Arr.AsciiArray, Count, skip=-1)
  Protected x, y, Result=#True
  
  Count-1
  
  For x=0 To Count
    For y=0 To Count
      If x<>y And (skip=-1 Or skip<>*Arr\a[x])
        If *Arr\a[x]=*Arr\a[y]
          Result=#False
          Break 2
        EndIf
      EndIf
    Next y
  Next x
  
  ProcedureReturn Result
EndProcedure

Procedure GetParam_WinSetting()
  Protected i
  
  With gSetting\Logic
    \Performance=Val(GetGadgetText(#sString_Perf))
    \TimeStable=Val(GetGadgetText(#sString_Stable))
    \DelayMode=Val(GetGadgetText(#sString_Delay))
    \TermoNextMode=GetGadgetState(#sSpin_Col1_TermoNextMode)
    \Col1_MinTermo=GetGadgetState(#sSpin_Col1_MinTermo)
    \MaxVolume_v0=Val(GetGadgetText(#sString_Valve0_MaxVol))
    \MaxVolume=Val(GetGadgetText(#sString_Valve1_MaxVol))
    \Valve1_PWM=GetGadgetState(#sSpin_Valve1_PWM)
    \Valve2_Stable=Val(GetGadgetText(#sString_Valve2_Stable))
    \Valve3_PWM=GetGadgetState(#sSpin_Valve3_PWM)
    \Valve3_Termo=GetGadgetState(#sSpin_Valve3_Termo)
    \Hysteresis_Col3=GetGadgetState(#sSpin_Col3_Hysteresis)
    \Check_d6=GetGadgetState(#sCheckbox_d6)
    \Termo_d6=GetGadgetState(#sSpin_d6_Termo)
    \Hysteresis_d6=GetGadgetState(#sSpin_d6_Hysteresis)
    \CheckCol1_Auto=GetGadgetState(#sCheckbox_Col1_Auto)
    \CheckStopColumn = GetGadgetState(#sCheckbox_CheckStopColumn)
  EndWith
  
  With gSetting\Log
    \InfoShow=GetGadgetState(#sCheckbox_LogInfo_Win)
    \InfoFile=GetGadgetState(#sCheckbox_LogInfo_File)
    \WarnShow=GetGadgetState(#sCheckbox_LogWarn_Win)
    \WarnFile=GetGadgetState(#sCheckbox_LogWarn_File)
    \ErrShow=GetGadgetState(#sCheckbox_LogErr_Win)
    \ErrFile=GetGadgetState(#sCheckbox_LogErr_File)
    \AutoScroll=GetGadgetState(#sCheckbox_Log_AutoScroll)
  EndWith
  
  With gSetting\Log\Termo
    \CheckSavesSec=GetGadgetState(#sCheckbox_TermoLog_SavesSec)
    \CheckModify=GetGadgetState(#sCheckbox_TermoLog_Modify)
    \CheckMaxTermo=GetGadgetState(#sCheckbox_TermoLog_MaxTermo)
    \CheckSensorErr=GetGadgetState(#sCheckbox_TermoLog_Err)
    \SavesSec=Val(GetGadgetText(#sString_TermoLog_SavesSec))
    \Modify=GetGadgetState(#sSpin_TermoLog_Modify)
    \MaxTermo=GetGadgetState(#sSpin_TermoLog_MaxTermo)
  EndWith
  
  With gSetting\Graph
    For i=0 To 8
      \Color[i]=GetGadgetItemData(#sCombo_GraphColor, i)
    Next i
    \NewDay = GetGadgetState(#sCheckbox_Graph_Save_NewDay)
    \AutoScroll = GetGadgetState(#sCheckbox_Graph_AutoScroll)
  EndWith
  
EndProcedure

Procedure SetParam_WinSetting()
  Protected i
  
  With gSetting\Logic
    SetGadgetText(#sString_Perf, Str(\Performance))
    SetGadgetText(#sString_Stable, Str(\TimeStable))
    SetGadgetText(#sString_Delay, Str(\DelayMode))
    SetSpinFloat(#sSpin_Col1_TermoNextMode, \TermoNextMode, #True)
    SetSpinFloat(#sSpin_Col1_MinTermo, \Col1_MinTermo, #True)
    SetGadgetText(#sString_Valve0_MaxVol, Str(\MaxVolume_v0))
    SetGadgetText(#sString_Valve1_MaxVol, Str(\MaxVolume))
    SetGadgetState(#sSpin_Valve1_PWM, \Valve1_PWM)
    SetGadgetText(#sString_Valve2_Stable, Str(\Valve2_Stable))
    SetGadgetState(#sSpin_Valve3_PWM, \Valve3_PWM)
    SetSpinFloat(#sSpin_Valve3_Termo, \Valve3_Termo, #True)
    SetSpinFloat(#sSpin_Col3_Hysteresis, \Hysteresis_Col3, #True)
    SetGadgetState(#sCheckbox_d6, \Check_d6)
    SetSpinFloat(#sSpin_d6_Termo, \Termo_d6, #True)
    SetSpinFloat(#sSpin_d6_Hysteresis, \Hysteresis_d6, #True)
    SetGadgetState(#sCheckbox_Col1_Auto, \CheckCol1_Auto)
    SetGadgetState(#sCheckbox_CheckStopColumn, \CheckStopColumn)
    
    If \Check_d6=0
      DisableGadget(#sSpin_d6_Termo, #True)
      DisableGadget(#sSpin_d6_Hysteresis, #True)
    EndIf
  
  EndWith
  
  With gSetting\Log
    SetGadgetState(#sCheckbox_LogInfo_Win, \InfoShow)
    SetGadgetState(#sCheckbox_LogInfo_File, \InfoFile)
    SetGadgetState(#sCheckbox_LogWarn_Win, \WarnShow)
    SetGadgetState(#sCheckbox_LogWarn_File, \WarnFile)
    SetGadgetState(#sCheckbox_LogErr_Win, \ErrShow)
    SetGadgetState(#sCheckbox_LogErr_File, \ErrFile)
    SetGadgetState(#sCheckbox_Log_AutoScroll, \AutoScroll)
  EndWith
  
  With gSetting\Log\Termo
    SetGadgetState(#sCheckbox_TermoLog_SavesSec, \CheckSavesSec)
    SetGadgetState(#sCheckbox_TermoLog_Modify, \CheckModify)
    SetGadgetState(#sCheckbox_TermoLog_MaxTermo, \CheckMaxTermo)
    SetGadgetState(#sCheckbox_TermoLog_Err, \CheckSensorErr)
    SetGadgetText(#sString_TermoLog_SavesSec, Str(\SavesSec))
    SetSpinFloat(#sSpin_TermoLog_Modify, \Modify, #True)
    SetSpinFloat(#sSpin_TermoLog_MaxTermo, \MaxTermo, #True)
    
    DisableGadget(#sString_TermoLog_SavesSec, \CheckSavesSec!1)
    DisableGadget(#sSpin_TermoLog_Modify, \CheckModify!1)
    DisableGadget(#sSpin_TermoLog_MaxTermo, \CheckMaxTermo!1)
  EndWith
  
  With gSetting\Graph
    For i=0 To 8
      SetGadgetItemData(#sCombo_GraphColor, i, \Color[i])
    Next i
    SetGadgetState(#sCheckbox_Graph_Save_NewDay, \NewDay)
    SetGadgetState(#sCheckbox_Graph_AutoScroll, \AutoScroll)
    SetGadgetState(#sCombo_GraphColor, 0)
    SetCanvasColor(#sCanvas_GraphColor, \Color[0])
  EndWith
  
  SetGadgetAttribute(#sString_Valve1_MaxVol, #PB_String_MaximumLength, 7)
  
EndProcedure


Procedure GetParam_sLPT()
  Protected s.sLPT, Result=#False
  
  s\Adr=Val(GetGadgetText(#sLPT_String_adr))
  s\Pins[#LPT_Pin_Pulse]=GetGadgetState(#sLPT_Combo_Pulse)
  s\Pins[#LPT_Pin_Col1]=GetGadgetState(#sLPT_Combo_Col1)
  s\Pins[#LPT_Pin_Valve0]=GetGadgetState(#sLPT_Combo_Valve0)
  s\Pins[#LPT_Pin_Valve1]=GetGadgetState(#sLPT_Combo_Valve1)
  s\Pins[#LPT_Pin_Valve2]=GetGadgetState(#sLPT_Combo_Valve2)
  s\Pins[#LPT_Pin_Valve3]=GetGadgetState(#sLPT_Combo_Valve3)
  s\Pins[#LPT_Pin_Col2]=GetGadgetState(#sLPT_Combo_Col2)
  s\Pins[#LPT_Pin_Col3_Max]=GetGadgetState(#sLPT_Combo_Col3_Max)
  s\Pins[#LPT_Pin_Col3_Min]=GetGadgetState(#sLPT_Combo_Col3_Min)
  s\Pins[#LPT_Pin_d6]=GetGadgetState(#sLPT_Combo_d6)
  s\Pins[#LPT_Pin_Err]=GetGadgetState(#sLPT_Combo_Err)
    
  If TestAsciiArray_Duplicate(@s\Pins[0], SizeOf(sLPT\Pins))=#True
    gSetting\LPT = s
    Result=#True
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure SetParam_sLPT()
  Protected i
  
  
  With gSetting\LPT
    SetGadgetText(#sLPT_String_adr, Str(\Adr))
    SetGadgetState(#sLPT_Combo_Pulse, \Pins[#LPT_Pin_Pulse])
    SetGadgetState(#sLPT_Combo_Col1, \Pins[#LPT_Pin_Col1])
    SetGadgetState(#sLPT_Combo_Valve0, \Pins[#LPT_Pin_Valve0])
    SetGadgetState(#sLPT_Combo_Valve1, \Pins[#LPT_Pin_Valve1])
    SetGadgetState(#sLPT_Combo_Valve2, \Pins[#LPT_Pin_Valve2])
    SetGadgetState(#sLPT_Combo_Valve3, \Pins[#LPT_Pin_Valve3])
    SetGadgetState(#sLPT_Combo_Col2, \Pins[#LPT_Pin_Col2])
    SetGadgetState(#sLPT_Combo_Col3_Max, \Pins[#LPT_Pin_Col3_Max])
    SetGadgetState(#sLPT_Combo_Col3_Min, \Pins[#LPT_Pin_Col3_Min])
    SetGadgetState(#sLPT_Combo_d6, \Pins[#LPT_Pin_d6])
    SetGadgetState(#sLPT_Combo_Err, \Pins[#LPT_Pin_Err])
  EndWith
  
  If gVar\IsWin9x=#True ; На Win9x устанавливать драйвер не нужно.
    HideGadget(#sLPT_Button_InstallDr, #True)
    HideGadget(#sLPT_Button_UnInstallDr, #True)
  EndIf
  
;   If dPort::dpID()
;     DisableGadget(#sLPT_Button_InstallDr, #True)
;   Else
;     DisableGadget(#sLPT_Button_UnInstallDr, #True)
;   EndIf
EndProcedure

Procedure.s SN_Text(*x.OW_SN)
  Protected String.s, i
  
  String = RSet(Hex(*x\Type), 2, "0")+"-"
  
  For i=5 To 0 Step -1
    String + RSet(Hex(*x\Number[i]), 2, "0")
  Next i
  
  String + "-"+RSet(Hex(*x\CRC), 2, "0")
  
  ProcedureReturn String
EndProcedure

Procedure WinSensor_SetTable()
  Protected CountSensor, CountItem
  Protected i, Temp, String.s
  
  If IsWindow(#Window_Sensors)
    With gVar\Sensors
      
      CountSensor = ListSize(\Sensor())
      CountItem = CountGadgetItems(#ss_ListIcon_TableSensor)
      
      If CountSensor>CountItem
        For i=CountItem To CountSensor-1
          AddGadgetItem(#ss_ListIcon_TableSensor, i, "")
          If SelectElement(\Sensor(), i)
            SetGadgetItemData(#ss_ListIcon_TableSensor, i, \Sensor()\Use)
          EndIf
        Next i
      ElseIf CountSensor<CountItem
        For i=CountItem-1 To CountSensor Step -1
          RemoveGadgetItem(#ss_ListIcon_TableSensor, i)
        Next i
      EndIf
      
      i=0
      ForEach \Sensor()
        SetGadgetItemText(#ss_ListIcon_TableSensor, i, SN_Text(@\Sensor()\ID), 0)
        
        
        Select GetGadgetItemData(#ss_ListIcon_TableSensor, i)
          Case #Sensor_Use_d1
            String="Датчик 1 (ав. ТСА)"
          Case #Sensor_Use_d2
            String="Датчик 2 (ав. Конденсатор)"
          Case #Sensor_Use_d3
            String="Датчик 3 (д. Колонна)"
          Case #Sensor_Use_d4
            String="Датчик 4 (д. Куб)"
          Case #Sensor_Use_d5
            String="Датчик 5 (д. Брага)"
          Case #Sensor_Use_d6
            String="Датчик 6"
          Default
            String="Не используется"
        EndSelect
        
        SetGadgetItemText(#ss_ListIcon_TableSensor, i, String, 1)
        
        String=""
        
        If \PortID And TestBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_NotFound)=#False
          If TestBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
            If TestBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_MoreErr)
              String="Ошибка чтения данных"
            Else
              String=StrF(\Sensor()\Termo/10, 1)+" °C"
            EndIf
          Else
            String="Не является датчиком температуры или несовместим с DS18B20"
          EndIf
        Else
          String="Датчик не найден"
        EndIf
        
        SetGadgetItemText(#ss_ListIcon_TableSensor, i, String, 2)
        
        i+1
      Next
      
    EndWith
  EndIf
EndProcedure

Procedure SetParam_sSensors()
  Protected i=0
  With gSetting\Sensor
    SetGadgetState(#ss_Combo_Port, \NumPort)
    WinSensor_SetTable()
    SetGadgetState(#ss_Checkbox_Serial, \Serial)
  EndWith
  ButtonDelSensor_State()
EndProcedure

Procedure GetParam_sSensors()
  Shared gSensorThread
  Protected i=0, Result=#True
  
  With gSetting\Sensor
    \NumPort = GetGadgetState(#ss_Combo_Port)
    \Serial  = GetGadgetState(#ss_Checkbox_Serial)
    
    ClearList(\sList())
    ForEach gVar\Sensors\Sensor()
      gVar\Sensors\Sensor()\Use = GetGadgetItemData(#ss_ListIcon_TableSensor, i)
      If AddElement(\sList())
        \sList()\ID=gVar\Sensors\Sensor()\ID
        \sList()\Use = gVar\Sensors\Sensor()\Use
      EndIf
      i+1
    Next
  EndWith
    
  LockMutex(gSensorThread\Mutex)
  gSensorThread\NumPort = gSetting\Sensor\NumPort
  gSensorThread\Serial  = gSetting\Sensor\Serial
  ClearList(gSensorThread\Sensor())
  ForEach gVar\Sensors\Sensor()
    If AddElement(gSensorThread\Sensor())
      gSensorThread\Sensor()\ID = gVar\Sensors\Sensor()\ID
      gSensorThread\Sensor()\Use = gVar\Sensors\Sensor()\Use
    EndIf
  Next
  ClearBit(gSensorThread\Flags, #ThS_FlagOut_SetData|#ThS_FlagOut_Find)
  SetBit(gSensorThread\Flags, #ThS_FlagIn_Setting)
  UnlockMutex(gSensorThread\Mutex)
    
  
  ProcedureReturn Result
EndProcedure

Procedure sSensors_Cancel()
  Shared gSensorThread
  Protected x
  With gSetting\Sensor
    
    
    ForEach gVar\Sensors\Sensor()
      x=#False
      ForEach \sList()
        If gVar\Sensors\Sensor()\ID = \sList()\ID
          x=#True
          Break
        EndIf
      Next
      If x=#False
        DeleteElement(gVar\Sensors\Sensor())
      EndIf
    Next
    
    ForEach \sList()
      x=#False
      ForEach gVar\Sensors\Sensor()
        If gVar\Sensors\Sensor()\ID = \sList()\ID
          x=#True
          Break
        EndIf
      Next
      If x=#False
        If AddElement(gVar\Sensors\Sensor())
          gVar\Sensors\Sensor()\ID = \sList()\ID
          gVar\Sensors\Sensor()\Use = \sList()\Use
          gVar\Sensors\Sensor()\Flag = 0
          If Sensor_IsTermoSensor(@gVar\Sensors\Sensor())
            SetBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
          EndIf
        EndIf
      EndIf
    Next
    
  EndWith
  
  LockMutex(gSensorThread\Mutex)
  gSensorThread\NumPort = gSetting\Sensor\NumPort
  gSensorThread\Serial  = gSetting\Sensor\Serial
  ClearList(gSensorThread\Sensor())
  ForEach gVar\Sensors\Sensor()
    If AddElement(gSensorThread\Sensor())
      gSensorThread\Sensor()\ID = gVar\Sensors\Sensor()\ID
      gSensorThread\Sensor()\Use = gVar\Sensors\Sensor()\Use
    EndIf
  Next
  ClearBit(gSensorThread\Flags, #ThS_FlagOut_SetData|#ThS_FlagOut_Find)
  SetBit(gSensorThread\Flags, #ThS_FlagIn_Setting|#ThS_FlagIn_ModifyPort)
  UnlockMutex(gSensorThread\Mutex)
  
  
EndProcedure

Procedure SetParam_WinMain()
  With gSetting\WinMain
    SetSpinFloat(#Spin_d1, \d1_Limit, #True)
    SetSpinFloat(#Spin_d2, \d2_Limit, #True)
    SetSpinFloat(#Spin_d3, \d3_Limit, #True)
    SetSpinFloat(#Spin_d4, \d4_Limit, #True)
    SetSpinFloat(#Spin_d5_Max, \d5_LimitMax, #True)
    SetSpinFloat(#Spin_d5_Min, \d5_LimitMin, #True)
  EndWith
EndProcedure

Procedure WinMain_Event(Event) ; Обработка событий главного окна программы.
  Shared gSensorThread
  Protected Type, ID, State
  
  Select Event
    Case #PB_Event_Gadget
      
      Type = EventType()
      ID = EventGadget()
      Select ID
        Case #Spin_d1, #Spin_d2, #Spin_d3, #Spin_d4, #Spin_d5_Max, #Spin_d5_Min

          If Type = #PB_EventType_Up Or Type = #PB_EventType_Down
            State = GetGadgetState(ID)
            SetSpinFloat(ID, State)
            
            With gSetting\WinMain
              Select ID
                Case #Spin_d1 : \d1_Limit = State
                Case #Spin_d2 : \d2_Limit = State
                Case #Spin_d3 : \d3_Limit = State
                Case #Spin_d4 : \d4_Limit = State
                Case #Spin_d5_Max : \d5_LimitMax = State
                Case #Spin_d5_Min : \d5_LimitMin = State
              EndSelect
              \UpdateSetting = 0
            EndWith
            
          EndIf
          
          
        Case #Canvas_Graph
          If Type = #PB_EventType_RightClick
            If gSetting\Graph\AutoScroll
              SetMenuItemState(#MenuPopup_Grph, #mItem_Graph_AutoScroll, 1)
            Else
              SetMenuItemState(#MenuPopup_Grph, #mItem_Graph_AutoScroll, 0)
            EndIf
            DisplayPopupMenu(#MenuPopup_Grph, WindowID(#Window_Main))
          EndIf
        Case #ListView_Log
          If Type = #PB_EventType_RightClick
            If gSetting\Log\AutoScroll
              SetMenuItemState(#MenuPopup_Log, #mItem_Log_AutoScroll, 1)
            Else
              SetMenuItemState(#MenuPopup_Log, #mItem_Log_AutoScroll, 0)
            EndIf
            DisplayPopupMenu(#MenuPopup_Log, WindowID(#Window_Main))
          EndIf
          
        Case #Button_Col1_Start
          ColumnSetStatus(#Col_1, #StatusStart)
        Case #Button_Col1_Pause
          ColumnSetStatus(#Col_1, #StatusPause)
        Case #Button_Col1_Stop
          If gSetting\Logic\CheckStopColumn=#False Or
             MessageRequester(GetWindowTitle(#Window_Main),
                              "Остановить работу колонки 1 (Ректификация)?", 
                              #PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)=#PB_MessageRequester_Yes
            ColumnSetStatus(#Col_1, #StatusStop)
          EndIf
        Case #Button_Col1_Skip
          If gSetting\Logic\CheckStopColumn=#False Or
             MessageRequester(GetWindowTitle(#Window_Main),
                              "Пропустить текущий режим колонки 1 (Ректификация)?", 
                              #PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)=#PB_MessageRequester_Yes
            ColumnSetStatus(#Col_1, #StatusSkip)
          EndIf
          
        
        Case #Button_Valve1
          If GetGadgetState(#Button_Valve1)
            SetGadgetState(#Button_Valve2, 0)
            SetGadgetState(#Button_Valve3, 0)
            SetGadgetText(#Button_Valve1, "Откр.")
            SetGadgetText(#Button_Valve2, "Закр.")
            SetGadgetText(#Button_Valve3, "Закр.")
            SetLedColor(#Led_Valve1,#LedColor_Green)
            SetLedColor(#Led_Valve2,#LedColor_Off)
            SetLedColor(#Led_Valve3,#LedColor_Off)
            gVar\Logic\Col1\ControlValves=1
          Else
            SetGadgetText(#Button_Valve1, "Закр.")
            SetLedColor(#Led_Valve1,#LedColor_Off)
            gVar\Logic\Col1\ControlValves=0
          EndIf
        Case #Button_Valve2
          If GetGadgetState(#Button_Valve2)
            SetGadgetState(#Button_Valve1, 0)
            SetGadgetState(#Button_Valve3, 0)
            SetGadgetText(#Button_Valve1, "Закр.")
            SetGadgetText(#Button_Valve2, "Откр.")
            SetGadgetText(#Button_Valve3, "Закр.")
            SetLedColor(#Led_Valve1,#LedColor_Off)
            SetLedColor(#Led_Valve2,#LedColor_Green)
            SetLedColor(#Led_Valve3,#LedColor_Off)
            gVar\Logic\Col1\ControlValves=2
          Else
            SetGadgetText(#Button_Valve2, "Закр.")
            SetLedColor(#Led_Valve2,#LedColor_Off)
            gVar\Logic\Col1\ControlValves=0
          EndIf
        Case #Button_Valve3
          If GetGadgetState(#Button_Valve3)
            SetGadgetState(#Button_Valve1, 0)
            SetGadgetState(#Button_Valve2, 0)
            SetGadgetText(#Button_Valve1, "Закр.")
            SetGadgetText(#Button_Valve2, "Закр.")
            SetGadgetText(#Button_Valve3, "Откр.")
            SetLedColor(#Led_Valve1,#LedColor_Off)
            SetLedColor(#Led_Valve2,#LedColor_Off)
            SetLedColor(#Led_Valve3,#LedColor_Green)
            gVar\Logic\Col1\ControlValves=3
          Else
            SetGadgetText(#Button_Valve3, "Закр.")
            SetLedColor(#Led_Valve3,#LedColor_Off)
            gVar\Logic\Col1\ControlValves=0
          EndIf
          
          
        Case #Button_Col2_Start
          ColumnSetStatus(#Col_2, #StatusStart)
        Case #Button_Col2_Stop
          If gSetting\Logic\CheckStopColumn=#False Or
             MessageRequester(GetWindowTitle(#Window_Main),
                              "Остановить работу колонки 2 (Дистилляция)?", 
                              #PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)=#PB_MessageRequester_Yes
            ColumnSetStatus(#Col_2, #StatusStop)
          EndIf
        Case #Button_Col3_Start
          ColumnSetStatus(#Col_3, #StatusStart)
        Case #Button_Col3_Stop
          If gSetting\Logic\CheckStopColumn=#False Or
             MessageRequester(GetWindowTitle(#Window_Main),
                              "Остановить работу колонки 3 (Брага)?", 
                              #PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)=#PB_MessageRequester_Yes
            ColumnSetStatus(#Col_3, #StatusStop)
          EndIf
      EndSelect
      
    Case #PB_Event_Menu
      ID = EventMenu()
      Select ID
        Case #mItem_Setting, #mItem_Graph_Setting, #mItem_Log_Setting ; Окно основных настроек программы.
          If IsWindow(#Window_Setting)=0
            OpenWindow_Setting()
            SetParam_WinSetting()
          Else
            SetWindowState(#Window_Setting, #PB_Window_Normal)
            SetActiveWindow(#Window_Setting)
          EndIf
          
          If ID<>#mItem_Setting
            If IsGadget(#sPanel_0)
              If ID=#mItem_Log_Setting
                SetGadgetState(#sPanel_0, 1)
              Else
                SetGadgetState(#sPanel_0, 2)
              EndIf
            EndIf
          EndIf
          
          HideWindow(#Window_Setting, #False)
          
        Case #mItem_LPT ; Окно настроек LPT порта.
          If IsWindow(#Window_sLPT)=0
            OpenWindow_sLPT()
            SetParam_sLPT()
            If OSVersion()>=#PB_OS_Windows_Vista
              SendMessage_(GadgetID(#sLPT_Button_InstallDr), #BCM_SETSHIELD, 0, #True)
              SendMessage_(GadgetID(#sLPT_Button_UnInstallDr), #BCM_SETSHIELD, 0, #True)
            EndIf
            HideWindow(#Window_sLPT, #False)
          Else
            SetWindowState(#Window_sLPT, #PB_Window_Normal)
            SetActiveWindow(#Window_sLPT)
          EndIf
        Case #mItem_Sensors ; Окно настроек датчиков температуры
          If IsWindow(#Window_Sensors)=0
            OpenWindow_Sensors()
            gSetting\Sensor\IsWindow=#True
            
            LockMutex(gSensorThread\Mutex)
            gSensorThread\IsWindow = gSetting\Sensor\IsWindow
            SetBit(gSensorThread\Flags, #ThS_FlagIn_WinSetting)
            UnlockMutex(gSensorThread\Mutex)
            
            If gVar\IsWin9x=#False
              SendMessage_(GadgetID(#ss_ListIcon_TableSensor), #LVM_SETEXTENDEDLISTVIEWSTYLE,
                           #LVS_EX_LABELTIP, #LVS_EX_LABELTIP)
              If OSVersion()>=#PB_OS_Windows_7
                SetWinTheme(GadgetID(#ss_ListIcon_TableSensor), "Explorer")
              EndIf
            EndIf
            
            SetParam_sSensors()
            HideWindow(#Window_Sensors, #False)
          Else
            SetWindowState(#Window_Sensors, #PB_Window_Normal)
            SetActiveWindow(#Window_Sensors)
          EndIf
          
        Case #mItem_Graph_AutoScroll
          gSetting\Graph\AutoScroll = GetMenuItemState(#MenuPopup_Grph, #mItem_Graph_AutoScroll)!1
          gSetting\WinMain\UpdateSetting=0
          CopyCraphSetting()
          If IsWindow(#Window_Setting) And IsGadget(#sCheckbox_Graph_AutoScroll)
            SetGadgetState(#sCheckbox_Graph_AutoScroll, gSetting\Graph\AutoScroll)
          EndIf
          
        Case #mItem_Log_AutoScroll
          gSetting\Log\AutoScroll = GetMenuItemState(#MenuPopup_Log, #mItem_Log_AutoScroll)!1
          gSetting\WinMain\UpdateSetting=0
          If IsWindow(#Window_Setting) And IsGadget(#sCheckbox_Log_AutoScroll)
            SetGadgetState(#sCheckbox_Log_AutoScroll, gSetting\Log\AutoScroll)
          EndIf

      EndSelect
      
  EndSelect
EndProcedure

Procedure Win_sLPT_Event(Event) ; Обработка событий окна настроек LPT порта.
  Protected s.s
  
  Select Event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #sLPT_Button_InstallDr
          
          
          If dPort::dpInstall()
            If dPort::dpOpenDriver()
              LogWrite("Драйвер LPT порта успешно устанвлен и запущен", #Log_TM_Info)
              ;DisableGadget(#sLPT_Button_InstallDr, #True)
              ;DisableGadget(#sLPT_Button_UnInstallDr, #False)
            Else
              LogWrite("Драйвер LPT порта успешно устанвлен но не запущен", #Log_TM_Warning)
            EndIf
          Else
            s="Не удалось установить драйвер LPT порта. Возможно он поврежден или нет прав администратора."
            LogWrite(s, #Log_TM_Warning)
            
            If OSVersion()>=#PB_OS_Windows_Vista And dPort::OSbits()
              s+Chr(10)+"Также возможно у него нет цифровой подписи (обязательно для x64 систем)"
            EndIf
            
            MessageRequester(GetWindowTitle(#Window_sLPT), s, #MB_ICONWARNING)
          EndIf
          
        Case #sLPT_Button_UnInstallDr
          
          dPort::dpClose()
          If dPort::dpUnInstall()
            ;DisableGadget(#sLPT_Button_InstallDr, #False)
            ;DisableGadget(#sLPT_Button_UnInstallDr, #True)
            LogWrite("Драйвер LPT порта успешно удален из системы", #Log_TM_Info)
          Else
            dPort::dpOpenDriver()
            s="Не удалось удалить драйвер LPT порта. Возможно он не установлен или нет прав администратора."
            LogWrite(s, #Log_TM_Warning)
            MessageRequester(GetWindowTitle(#Window_sLPT), s, #MB_ICONWARNING)
          EndIf
          
        Case #sLPT_Button_OK
          If GetParam_sLPT()=#True
            SaveSetting()
            CloseWindow(#Window_sLPT)
          Else
            MessageRequester(GetWindowTitle(#Window_sLPT),
                             "Одному или более выводу LPT порта назначено несколько функций!", #MB_ICONWARNING)
          EndIf
        Case #sLPT_Button_Cancel
          CloseWindow(#Window_sLPT)
      EndSelect
    Case #PB_Event_CloseWindow
      CloseWindow(#Window_sLPT)
  EndSelect
  
EndProcedure

Procedure WinSensors_Event(Event) ; Обработка событий окна настроек датчиков температуры
  Shared gSensorThread
  Static lItem
  Protected Type, Temp, i, x, Count
  
  Select Event
    Case #PB_Event_Gadget
      Type = EventType()
      Select EventGadget()
        Case #ss_Combo_Port
          Temp = GetGadgetState(#ss_Combo_Port)
          
          LockMutex(gSensorThread\Mutex)
          gSensorThread\NumPort = Temp
          gSensorThread\Serial = gSetting\Sensor\Serial
          SetBit(gSensorThread\Flags, #ThS_FlagIn_ModifyPort)
          UnlockMutex(gSensorThread\Mutex)
          
        Case #ss_Button_FindSensor ; Поиск датчиков.
          
          LogWrite("Начат поиск датчиков. На это потребуется некоторое время.", #Log_TM_Info)
          
          LockMutex(gSensorThread\Mutex)
          SetBit(gSensorThread\Flags, #ThS_FlagIn_Find)
          UnlockMutex(gSensorThread\Mutex)
          
        Case #ss_Button_DelSensor  ; Удалить не найденные.
          
          If MessageRequester(GetWindowTitle(#Window_Sensors),
                              "Удалить не найденные датчики?",
                              #PB_MessageRequester_YesNo|#MB_ICONQUESTION|
                              #MB_DEFBUTTON2) = #PB_MessageRequester_Yes
            With gVar\Sensors
              ForEach \Sensor()
                If TestBit(\Sensor()\Flag, #SensorsFlag_NotFound)
                  DeleteElement(\Sensor())
                EndIf
              Next
            EndWith
            WinSensor_SetTable()
            DisableGadget(#ss_Button_DelSensor, #True)
          EndIf
          
        Case #ss_ListIcon_TableSensor
          If Type = #PB_EventType_RightClick
            Temp = GetGadgetState(#ss_ListIcon_TableSensor)
            If Temp>=0
              
              If SelectElement(gVar\Sensors\Sensor(), Temp)
                
                If TestBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
                  lItem = Temp
                  Temp = GetGadgetItemData(#ss_ListIcon_TableSensor, Temp)
                  For i=#mItem_Sensor_None To #mItem_Sensor_d6
                    If i-#mItem_Sensor_None=Temp
                      SetMenuItemState(#MenuPopup_Sensor, i, 1)
                    Else
                      SetMenuItemState(#MenuPopup_Sensor, i, 0)
                    EndIf
                  Next
                  DisplayPopupMenu(#MenuPopup_Sensor, WindowID(#Window_Sensors))
                Else
                  MessageRequester(GetWindowTitle(#Window_Sensors),
                                   "Это 1-Wire устройсво не является датчиком, совместимым с DS18B20.",
                                   #MB_ICONWARNING)
                EndIf
              EndIf
              
            EndIf
          EndIf
        Case #ss_Checkbox_Serial
          SetBit(gVar\Sensors\Flags, #SensorsAll_Flag_Start)
        Case #ss_Button_OK
          gSetting\Sensor\IsWindow=#False
          
          LockMutex(gSensorThread\Mutex)
          gSensorThread\IsWindow = gSetting\Sensor\IsWindow
          SetBit(gSensorThread\Flags, #ThS_FlagIn_WinSetting)
          UnlockMutex(gSensorThread\Mutex)
          
          If GetParam_sSensors()
            SaveSetting()
            CloseWindow(#Window_Sensors)
            lItem=-1
          EndIf
        Case #ss_Button_Cancel
          gSetting\Sensor\IsWindow=#False
          
          LockMutex(gSensorThread\Mutex)
          gSensorThread\IsWindow = gSetting\Sensor\IsWindow
          SetBit(gSensorThread\Flags, #ThS_FlagIn_WinSetting)
          UnlockMutex(gSensorThread\Mutex)
          
          sSensors_Cancel()
          CloseWindow(#Window_Sensors)
          lItem=-1
        Case #ss_Button_Apply
          If GetParam_sSensors()
            SaveSetting()
          EndIf
      EndSelect
    Case #PB_Event_Menu
      Temp = EventMenu()
      If Temp>=#mItem_Sensor_None And Temp<=#mItem_Sensor_d6
        
        If lItem>=0
          
          x=#False
          
          If Temp-#mItem_Sensor_None>0
            Count = CountGadgetItems(#ss_ListIcon_TableSensor)-1
            For i=0 To Count
              If i<>lItem And GetGadgetItemData(#ss_ListIcon_TableSensor, i) = Temp-#mItem_Sensor_None
                x=#True
                Break
              EndIf
            Next i
            
            If x=#True
              If MessageRequester(GetWindowTitle(#Window_Sensors),
                                  "Эта функция назначена другому датчику."+#CRLF$+"Переназначить?",
                                  #PB_MessageRequester_YesNo|#MB_ICONQUESTION|
                                  #MB_DEFBUTTON2) = #PB_MessageRequester_Yes
                For i=0 To Count
                  If i<>lItem And GetGadgetItemData(#ss_ListIcon_TableSensor, i) = Temp-#mItem_Sensor_None
                    SetGadgetItemData(#ss_ListIcon_TableSensor, i, #Sensor_Use_None)
                  EndIf
                Next i
                x=#False
              EndIf
            EndIf
          EndIf
          
          If x=#False
            SetGadgetItemData(#ss_ListIcon_TableSensor, lItem, Temp-#mItem_Sensor_None)
            WinSensor_SetTable()
          EndIf
        
        EndIf
        
      EndIf
    Case #PB_Event_CloseWindow
      gSetting\Sensor\IsWindow=#False
      
      LockMutex(gSensorThread\Mutex)
      gSensorThread\IsWindow = gSetting\Sensor\IsWindow
      SetBit(gSensorThread\Flags, #ThS_FlagIn_WinSetting)
      UnlockMutex(gSensorThread\Mutex)
      
      
      sSensors_Cancel()
      CloseWindow(#Window_Sensors)
      lItem=-1
  EndSelect
EndProcedure

Procedure WinSetting_Event(Event) ; Обработка событий окна основных настроек программы
  Protected Type, ID, Temp
  
  Select Event
    Case #PB_Event_Gadget
      ID = EventGadget()
      Type = EventType()
      
      Select ID
          
        Case #sSpin_Valve3_Termo, #sSpin_TermoLog_Modify, #sSpin_TermoLog_MaxTermo, #sSpin_Col1_MinTermo,
             #sSpin_d6_Termo, #sSpin_d6_Hysteresis, #sSpin_Col1_TermoNextMode, #sSpin_Col3_Hysteresis
          If Type = #PB_EventType_Up Or Type = #PB_EventType_Down
            SetSpinFloat(ID, GetGadgetState(ID))
          EndIf
          
        Case #sCombo_GraphColor
          SetCanvasColor(#sCanvas_GraphColor,
                         GetGadgetItemData(#sCombo_GraphColor, GetGadgetState(#sCombo_GraphColor)))
          
        Case #sCanvas_GraphColor
          If Type = #PB_EventType_LeftClick
            Goto m1
          ElseIf Type = #PB_EventType_KeyUp
            Temp = GetGadgetAttribute(#sCanvas_GraphColor, #PB_Canvas_Key)
            If Temp =  #PB_Shortcut_Space
              m1:
              Temp = ColorRequester(GetGadgetItemData(#sCombo_GraphColor,
                                                      GetGadgetState(#sCombo_GraphColor)))
              If Temp>-1
                SetCanvasColor(#sCanvas_GraphColor, Temp)
                SetGadgetItemData(#sCombo_GraphColor, GetGadgetState(#sCombo_GraphColor), Temp)
              EndIf
            EndIf
          EndIf
          
          
        Case #sCheckbox_TermoLog_SavesSec
          DisableGadget(#sString_TermoLog_SavesSec, GetGadgetState(#sCheckbox_TermoLog_SavesSec)!1)
        Case #sCheckbox_TermoLog_Modify
          DisableGadget(#sSpin_TermoLog_Modify, GetGadgetState(#sCheckbox_TermoLog_Modify)!1)
        Case #sCheckbox_TermoLog_MaxTermo
          DisableGadget(#sSpin_TermoLog_MaxTermo, GetGadgetState(#sCheckbox_TermoLog_MaxTermo)!1)
          
        Case #sCheckbox_d6
          Temp = GetGadgetState(#sCheckbox_d6)!1
          DisableGadget(#sSpin_d6_Termo, Temp)
          DisableGadget(#sSpin_d6_Hysteresis, Temp)
          
        Case #sButton_OK
          GetParam_WinSetting()
          CopyCraphSetting()
          grh::GraphDraw()
          SaveSetting()
          CloseWindow(#Window_Setting)
        Case #sButton_Cancel
          CloseWindow(#Window_Setting)
        Case #sButton_Apply
          GetParam_WinSetting()
          CopyCraphSetting()
          grh::GraphDraw()
          SaveSetting()
      EndSelect
      
    Case #PB_Event_CloseWindow
      CloseWindow(#Window_Setting)
  EndSelect
EndProcedure



; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = -----
; EnableUnicode
; EnableXP
; CompileSourceDirectory